﻿import flash.display.BitmapData;
import flash.geom.Rectangle;
import flash.geom.Point;
import flash.geom.Matrix;


class ImageStreak {
	private var image_mc:MovieClip;
	private var container_mc:MovieClip;
	private var holder_mc:MovieClip;
	private var status_txt:TextField;
	
	private var my_bitmap:BitmapData;
	private var a_bitmap:BitmapData;
	private var my_mcl:MovieClipLoader;
	
	private var my_width:Number;
	private var my_height:Number;
	private var count:Number;
	
	private var background_color:Number;
	private var border_color:Number = 0x888888;
	
	private var my_interval:Number;
	private var draw_speed:Number = 20;
	private var step:Number = 1;
	
	public function ImageStreak( _mc:MovieClip, depth:Number, w:Number, h:Number, backgroundColor:Number ) {
		container_mc 	= _mc;
		my_width 		= w;
		my_height 		= h;
		background_color = backgroundColor;
		
		container_mc = _mc.createEmptyMovieClip( "imageStreak_mc" + depth, depth );
		image_mc = container_mc.createEmptyMovieClip( "image_mc", 2 );
													  
		my_bitmap = new BitmapData( my_width, my_height, false, background_color ); 
		image_mc.attachBitmap( my_bitmap, 1 );
		my_mcl = new MovieClipLoader();
		my_mcl.addListener( this );
	}
	
	public function load_image( url:String ):Void {
		holder_mc = container_mc.createEmptyMovieClip( "holder_mc", 1 );
		my_mcl.loadClip( url, holder_mc );
		
		// Create a status field 
		status_txt = container_mc.createTextField( "loadStatus_txt", 11, 0, 0, 0, 0 );
		status_txt.setNewTextFormat( new TextFormat( "Arial, Helvetica, _sans", 10, border_color, false, false, null, null, "right" ) );
		status_txt.autoSize = "left";
		status_txt._x = 5;
		status_txt._y = 5;
		status_txt.text = "Loading";
	}
	
	
	public function onLoadStart():Void {
		// nOthing goin' on here. 
	}
	
	public function onLoadProgress( mc:MovieClip, b:Number, t:Number ):Void {
		var p = Math.round( b / t * 100 );
		status_txt.text = "Loading " + p + "%";
	}
	
	public function onLoadComplete():Void {
		// Too bad this function wasn't used for anything.
	}
	
	public function onLoadInit() {
		status_txt.removeTextField();
		
		a_bitmap = new BitmapData( my_width, my_height, true, background_color );
		
		var tx = ( my_width - holder_mc._width ) / 2;
		var ty = ( my_height - holder_mc._height ) / 2;
		var center_matrix:Matrix = new Matrix( );
		center_matrix.translate( tx, ty );
		a_bitmap.draw( holder_mc, center_matrix );
		
		next_image();
		holder_mc.removeMovieClip();
	}
	
	public function onLoadError() {
		holder_mc.removeMovieClip()
	}
	
	
	
	public function next_image():Void {
		count = 0;
		// var secs = draw_speed / my_width * 1000;
		// trace( secs );
		my_interval = setInterval( this, "draw_streaks", draw_speed );
	}

	
	// ******* Here's where we draw the image *****
	public function draw_streaks():Void {
		for ( var i = 0; i < my_height; i++ ) {
			var copy_rect = new Rectangle( count, i, step, 1 );
			var dest_point = new Point( count, i );
			my_bitmap.copyPixels( a_bitmap, copy_rect, dest_point );
			
			var slice_rect = new Rectangle( count + step, i, my_width - count - step, 1 ); 
			var my_color = a_bitmap.getPixel32( count + step, i );
			my_bitmap.fillRect( slice_rect, my_color );
		}
		
		count += step;
		
		if ( count > my_width ) {
			// trace( "All Done" );
			clearInterval( my_interval );
		}
	}
	
	
	public function setStep( n:Number ):Void {
		step = n;
	}
	
	
	public function setSpeed( secs:Number ):Void {
		draw_speed = secs;
	}
	
	public function set_border( stroke_weight:Number, bc:Number ):Void {
		border_color = bc;
		
		var border_mc = container_mc.createEmptyMovieClip( "border_mc", 12 );
		border_mc.lineStyle( stroke_weight, border_color );
		border_mc.moveTo( 0, 0 );
		border_mc.lineTo( my_width, 0 );
		border_mc.lineTo( my_width, my_height );
		border_mc.lineTo( 0, my_height );
		border_mc.lineTo( 0, 0 );
	}
	
}




